/* 
   LINWLOAD ver 0.2a
   (c) Wojciech M. Zabolotny (wzab@ise.pw.edu.pl) 17.09.2000
   This file is published under the Gnu Public License version 2

   This is a program for using WLoader in Linux OS
   commands:
   PORT com_device baud_rate
   PROG hex_file
   VERIFY hex_file
   GO
   TERM

   The examples of proper calling syntax:
   linwload PORT /dev/ttyS3 19200 PROG myprog.hex GO
   linwload PORT /dev/ttyS3 19200 VERIFY myprog.hex
   linwload PORT /dev/ttyS3 19200 TERM


*/
#include "linwload.h"


//The communication routines

int CtrlBrkHandler(void)
{
  rsleave();
  printf("\n User Break!\n");
  return 0;
}

void dump()
{
  int i;
  for (i=0;i<MEM_LEN;i++)
    if(Used[i])
      printf("Addr: %x Val: %x \n",i,Mem[i]);
}

#define ISARG(x) (!strcmp(_argv[ArgPtr],x))
int main(int _argc, char * _argv[])
{
  FILE *f;
  //  int a,len,len2,i;
  int ArgPtr = 1; //Pointer to the interpreted command line option
  time_t time1;
  setvbuf(stdin,NULL,_IONBF,0);
  setvbuf(stdout,NULL,_IONBF,0);
  atexit(restoreterm);
  system("stty -icanon -echo");
  
  // Interprete the command line parameters
  while (ArgPtr < _argc )
    {
      if (ISARG("PORT"))
	{
	  int rate=-1;
	  if(Com_fd!=-1) rsleave(); //If another port was used previously, close it
	  ComDevice = _argv[++ArgPtr];
	  sscanf(_argv[++ArgPtr],"%d",&rate);
	  switch(rate)
	    {
	    case 19200:
	      BaudRate = B19200;
	      break;
	    case 9600:
	      BaudRate = B9600;
	      break;
	    default:
	      fprintf(stderr,"Invalid baudrate: %d\n",rate);
	      exit(-1);
	    }
	  ++ArgPtr;
	}
      else if (ISARG("PROG"))
	{
	  HexRead(_argv[++ArgPtr]);
	  Prog();
	  ++ArgPtr;
	}
      else if (ISARG("VERIFY"))
	{
	  HexRead(_argv[++ArgPtr]);
	  Verify();
	  ++ArgPtr;
	}
      else if (ISARG("GO"))
	{
	  Go();
	  ++ArgPtr;
	}
      else if (ISARG("TERM"))
	{
	  if(Com_fd==-1) rsinit();
	  terminal();
	  ++ArgPtr;
	}
      else
	{
	      fprintf(stderr,"Invalid command: %s\n",_argv[ArgPtr]);
	      exit(-1);
	}
    }
  if(Com_fd!=-1) rsleave();
  return 0;
}
